searchNodes=[{"doc":"Exposes all of the global Process Registry and Process Group APIs. Syn implement Scopes. You may think of Scopes such as database tables, so a set of data elements, but that's where the analogy ends. A Scope is a way to create a namespaced, logical overlay network running on top of the Erlang distribution cluster. Nodes that belong to the same Scope will form a subcluster: they will synchronize data between themselves, and themselves only. For instance, you may have nodes in your Erlang cluster that need to handle connections to users, and other nodes that need to handle connections to physical devices. One approach is to create two Scopes: users and devices , where you can register your different types of connections. Scopes are therefore a way to properly namespace your logic, but they also allow to build considerably larger scalable architectures, as it is possible to divide an Erlang cluster into subclusters which hold specific portions of data. Please note any of the methods documented here will raise: An error({invalid_scope, Scope}) if the local node has not been added to the specified Scope. An error({invalid_remote_scope, Scope, RemoteNode}) if the Pid passed in as variable is running on a node that has not been added to the specified Scope, or if the remote scope process is temporarily down. Quickstart Registry Elixir iex &gt; : syn . add_node_to_scopes ( [ : users ] ) : ok iex &gt; pid = self ( ) # PID &lt; 0.105 . 0 &gt; iex &gt; : syn . register ( : users , &quot;hedy&quot; , pid ) : ok iex &gt; : syn . lookup ( : users , &quot;hedy&quot; ) { # PID &lt; 0.105 . 0 &gt; , : undefined } iex &gt; : syn . register ( : users , &quot;hedy&quot; , pid , [ city : &quot;Milan&quot; ] ) : ok iex &gt; : syn . lookup ( : users , &quot;hedy&quot; ) { # PID &lt; 0.105 . 0 &gt; , [ city : &quot;Milan&quot; ] } iex &gt; : syn . registry_count ( : users ) 1 Erlang 1 &gt; syn : add_node_to_scopes ( [ users ] ) . ok 2 &gt; Pid = self ( ) . &lt; 0.93 . 0 &gt; 3 &gt; syn : register ( users , &quot;hedy&quot; , Pid ) . ok 4 &gt; syn : lookup ( users , &quot;hedy&quot; ) . { &lt; 0.93 . 0 &gt; , undefined } 5 &gt; syn : register ( users , &quot;hedy&quot; , Pid , [ { city , &quot;Milan&quot; } ] ) . ok 6 &gt; syn : lookup ( users , &quot;hedy&quot; ) . { &lt; 0.93 . 0 &gt; , [ { city , &quot;Milan&quot; } ] } 7 &gt; syn : registry_count ( users ) . 1 Process Groups Elixir iex &gt; : syn . add_node_to_scopes ( [ : users ] ) : ok iex &gt; pid = self ( ) # PID &lt; 0.88 . 0 &gt; iex &gt; : syn . join ( : users , { : italy , : lombardy } , pid ) : ok iex &gt; : syn . members ( : users , { : italy , : lombardy } ) [ { # PID &lt; 0.88 . 0 &gt; , : undefined } ] iex &gt; : syn . is_member ( : users , { : italy , : lombardy } , pid ) true iex &gt; : syn . publish ( : users , { : italy , : lombardy } , &quot;hello lombardy!&quot; ) { : ok , 1 } iex &gt; flush ( ) Shell got &quot;hello lombardy!&quot; ok Erlang 1 &gt; syn : add_node_to_scopes ( [ users ] ) . ok 2 &gt; Pid = self ( ) . &lt; 0.88 . 0 &gt; 3 &gt; syn : join ( users , { italy , lombardy } , Pid ) . ok 4 &gt; syn : members ( users , { italy , lombardy } ) . [ { &lt; 0.88 . 0 &gt; , undefined } ] 5 &gt; syn : is_member ( users , { italy , lombardy } , Pid ) . true 6 &gt; syn : publish ( users , { italy , lombardy } , &quot;hello lombardy!&quot; ) . { ok , 1 } 7 &gt; flush ( ) . Shell got &quot;hello lombardy!&quot; ok","ref":"syn.html","title":"syn","type":"module"},{"doc":"Add the local node to the specified Scopes . There are 2 ways to add a node to Scopes. One is by using this method, the other is to set the environment variable syn with the key scopes . In this latter case, you're probably best off using an application configuration file: You only need to add a node to a scope once. Elixir config : syn , scopes : [ : devices , : users ] Erlang { syn , [ { scopes , [ devices , users ] } ] } Examples Elixir iex &gt; : syn . add_node_to_scopes ( [ : devices ] ) : ok Erlang 1 &gt; syn : add_node_to_scopes ( [ devices ] ) . ok","ref":"syn.html#add_node_to_scopes/1","title":"syn.add_node_to_scopes/1","type":"function"},{"doc":"Returns the count of all the groups for the specified Scope. Examples Elixir iex &gt; : syn . group_count ( : users ) 321778 Erlang 1 &gt; syn : group_count ( users ) . 321778","ref":"syn.html#group_count/1","title":"syn.group_count/1","type":"function"},{"doc":"Returns the count of all the groups for the specified Scope which have at least 1 process running on Node .","ref":"syn.html#group_count/2","title":"syn.group_count/2","type":"function"},{"doc":"Returns the group names for the specified Scope. The order of the group names is not guaranteed to be the same on all calls. Examples Elixir iex &gt; : syn . group_names ( : users ) [ &quot;area-1&quot; , &quot;area-2&quot; ] Erlang 1 &gt; syn : group_names ( users ) . [ &quot;area-1&quot; , &quot;area-2&quot; ]","ref":"syn.html#group_names/1","title":"syn.group_names/1","type":"function"},{"doc":"Returns the group names for the specified Scope which have at least 1 process running on Node . The order of the group names is not guaranteed to be the same on all calls.","ref":"syn.html#group_names/2","title":"syn.group_names/2","type":"function"},{"doc":"Returns whether a pid() is a member of GroupName in the specified Scope running on the local node.","ref":"syn.html#is_local_member/3","title":"syn.is_local_member/3","type":"function"},{"doc":"Returns whether a pid() is a member of GroupName in the specified Scope.","ref":"syn.html#is_member/3","title":"syn.is_member/3","type":"function"},{"doc":"Equivalent to join(Scope, GroupName, Pid, undefined) .","ref":"syn.html#join/3","title":"syn.join/3","type":"function"},{"doc":"Adds a pid() with metadata to GroupName in the specified Scope. A process can join multiple groups. A process may also join the same group multiple times, for example if you need to update its metadata, however it is RECOMMENDED to be aware of the implications of updating metadata, see the strict_mode option for more information. When a process joins a group, Syn will automatically monitor it. Possible error reasons: not_alive : The pid() being added is not alive. not_self : the method is being called from a process other than self() , but strict_mode is enabled. Examples Elixir iex &gt; : syn . join ( : devices , &quot;area-1&quot; , self ( ) , [ meta : : one ] ) : ok Erlang 1 &gt; syn : join ( devices , &quot;area-1&quot; , self ( ) , [ { meta , one } ] ) . ok","ref":"syn.html#join/4","title":"syn.join/4","type":"function"},{"doc":"Removes a pid() from GroupName in the specified Scope. Possible error reasons: not_in_group : The pid() is not in GroupName for the specified Scope. You don't need to remove processes that are about to die, since they are monitored by Syn and they will be removed automatically from their groups.","ref":"syn.html#leave/3","title":"syn.leave/3","type":"function"},{"doc":"Equivalent to group_count(Scope, node()) .","ref":"syn.html#local_group_count/1","title":"syn.local_group_count/1","type":"function"},{"doc":"Equivalent to group_names(Scope, node()) .","ref":"syn.html#local_group_names/1","title":"syn.local_group_names/1","type":"function"},{"doc":"Returns the list of all members for GroupName in the specified Scope running on the local node.","ref":"syn.html#local_members/2","title":"syn.local_members/2","type":"function"},{"doc":"Publish a message to all group members running on the local node in the specified Scope. Works similarly to publish/3 for local processes.","ref":"syn.html#local_publish/3","title":"syn.local_publish/3","type":"function"},{"doc":"Equivalent to registry_count(Scope, node()) .","ref":"syn.html#local_registry_count/1","title":"syn.local_registry_count/1","type":"function"},{"doc":"Looks up a registry entry in the specified Scope. Examples Elixir iex &gt; : syn . register ( : devices , &quot;SN-123-456789&quot; , self ( ) ) : ok iex &gt; : syn . lookup ( : devices , &quot;SN-123-456789&quot; ) { # PID &lt; 0.105 . 0 &gt; , undefined } Erlang 1 &gt; syn : register ( devices , &quot;SN-123-456789&quot; , self ( ) ) . ok 2 &gt; syn : lookup ( devices , &quot;SN-123-456789&quot; ) . { &lt; 0.79 . 0 &gt; , undefined }","ref":"syn.html#lookup/2","title":"syn.lookup/2","type":"function"},{"doc":"Returns the list of all members for GroupName in the specified Scope. Examples Elixir iex &gt; : syn . join ( : devices , &quot;area-1&quot; ) : ok iex &gt; : syn . members ( : devices , &quot;area-1&quot; ) [ { # PID &lt; 0.105 . 0 &gt; , : undefined } ] Erlang 1 &gt; syn : join ( devices , &quot;area-1&quot; , self ( ) ) . ok 2 &gt; syn : members ( devices , &quot;area-1&quot; ) . [ { &lt; 0.69 . 0 &gt; , undefined } ]","ref":"syn.html#members/2","title":"syn.members/2","type":"function"},{"doc":"Equivalent to multi_call(Scope, GroupName, Message, 5000) .","ref":"syn.html#multi_call/3","title":"syn.multi_call/3","type":"function"},{"doc":"Calls all group members in the specified Scope and collects their replies. When this call is issued, all members will receive a tuple in the format: {syn_multi_call, TestMessage, Caller, Meta} To reply, every member MUST use the method multi_call_reply/2 . Syn will wait up to the value specified in Timeout to receive all replies from the members. The responses will be added to the Replies list, while the members that do not reply in time or that crash before sending a reply will be added to the BadReplies list.","ref":"syn.html#multi_call/4","title":"syn.multi_call/4","type":"function"},{"doc":"Allows a group member to reply to a multi call. See multi_call/4 for info.","ref":"syn.html#multi_call_reply/2","title":"syn.multi_call_reply/2","type":"function"},{"doc":"Retrieves the Scopes that the node has been added to.","ref":"syn.html#node_scopes/0","title":"syn.node_scopes/0","type":"function"},{"doc":"Publish a message to all group members in the specified Scope. RecipientCount is the count of the intended recipients. Examples Elixir iex &gt; : syn . join ( : users , &quot;area-1&quot; , self ( ) ) : ok iex &gt; : syn . publish ( : users , &quot;area-1&quot; , : my_message ) { : ok , 1 } iex &gt; flush ( ) Shell got : my_message : ok Erlang 1 &gt; syn : join ( users , &quot;area-1&quot; , self ( ) ) . ok 2 &gt; syn : publish ( users , &quot;area-1&quot; , my_message ) . { ok , 1 } 3 &gt; flush ( ) . Shell got my_message ok","ref":"syn.html#publish/3","title":"syn.publish/3","type":"function"},{"doc":"Equivalent to register(Scope, Name, Pid, undefined) .","ref":"syn.html#register/3","title":"syn.register/3","type":"function"},{"doc":"Registers a process with metadata in the specified Scope. You may register the same process with different names. You may also re-register a process multiple times, for example if you need to update its metadata, however it is RECOMMENDED to be aware of the implications of updating metadata, see the strict_mode option for more information. When a process gets registered, Syn will automatically monitor it. Possible error reasons: not_alive : The pid() being registered is not alive. taken : name is already registered with another pid() . not_self : the method is being called from a process other than self() , but strict_mode is enabled. Examples Elixir iex &gt; : syn . register ( : devices , &quot;SN-123-456789&quot; , self ( ) , [ meta : : one ] ) : ok iex &gt; : syn . lookup ( : devices , &quot;SN-123-456789&quot; ) { # PID &lt; 0.105 . 0 &gt; , [ meta : : one ] } Erlang 1 &gt; syn : register ( devices , &quot;SN-123-456789&quot; , self ( ) , [ { meta , one } ] ) . ok 2 &gt; syn : lookup ( devices , &quot;SN-123-456789&quot; ) { &lt; 0.105 . 0 &gt; , [ { meta , one } ] } Processes can also be registered as gen_server names, by usage of via-tuples. This way, you can use the gen_server API with these tuples without referring to the Pid directly. If you do so, you MUST use a gen_server name in format {Scope, Name} , i.e. your via tuple will look like {via, syn, {my_scope, &lt;&lt;&quot;process name&quot;&gt;&gt;}} . See here below for examples. Examples Elixir iex &gt; tuple = { : via , : syn , { : devices , &quot;SN-123-456789&quot; } } . { : via , : syn , { : devices , &quot;SN-123-456789&quot; } } iex &gt; GenServer . start_link ( _ _ MODULE__ , [ ] , name : tuple ) { ok , # PID &lt; 0.105 . 0 &gt; } iex &gt; GenServer . call ( tuple , : your_message ) : your_message Erlang 1 &gt; Tuple = { via , syn , { devices , &quot;SN-123-456789&quot; } } . { via , syn , { devices , &quot;SN-123-456789&quot; } } 2 &gt; gen_server : start_link ( Tuple , your_module , [ ] ) . { ok , &lt; 0.79 . 0 &gt; } 3 &gt; gen_server : call ( Tuple , your_message ) . your_message","ref":"syn.html#register/4","title":"syn.register/4","type":"function"},{"doc":"Returns the count of all registered processes for the specified Scope. Examples Elixir iex &gt; : syn . registry_count ( : devices ) 512473 Erlang 1 &gt; syn : registry_count ( devices ) . 512473","ref":"syn.html#registry_count/1","title":"syn.registry_count/1","type":"function"},{"doc":"Returns the count of all registered processes for the specified Scope running on a node.","ref":"syn.html#registry_count/2","title":"syn.registry_count/2","type":"function"},{"doc":"Sets the handler module. Please see syn_event_handler for information on callbacks. There are 2 ways to set a handler module. One is by using this method, the other is to set the environment variable syn with the key event_handler . In this latter case, you're probably best off using an application configuration file: Elixir config : syn , event_handler : MyCustomEventHandler Erlang { syn , [ { event_handler , my_custom_event_handler } ] } Examples Elixir iex &gt; : syn . set_event_handler ( MyCustomEventHandler ) ok Erlang 1 &gt; syn : set_event_handler ( my_custom_event_handler ) . ok","ref":"syn.html#set_event_handler/1","title":"syn.set_event_handler/1","type":"function"},{"doc":"Starts Syn manually. In most cases Syn will be started as one of your application's dependencies, however you may use this helper method to start it manually.","ref":"syn.html#start/0","title":"syn.start/0","type":"function"},{"doc":"Stops Syn manually.","ref":"syn.html#stop/0","title":"syn.stop/0","type":"function"},{"doc":"Returns the nodes of the subcluster for the specified Scope.","ref":"syn.html#subcluster_nodes/2","title":"syn.subcluster_nodes/2","type":"function"},{"doc":"Unregisters a process from specified Scope. Possible error reasons: undefined : name is not registered. race_condition : the local pid() does not correspond to the cluster value, so Syn will not succeed unregistering the value and will wait for the cluster to synchronize. This is a rare occasion. You don't need to unregister names of processes that are about to die, since they are monitored by Syn and they will be removed automatically.","ref":"syn.html#unregister/2","title":"syn.unregister/2","type":"function"},{"doc":"Defines Syn's callbacks. You can specify the callback module with syn:set_event_handler/1 . In your module you need to specify the behavior syn_event_handler and implement the callbacks. All callbacks are optional, so you just need to define the ones you need. All of the callbacks, except for resolve_registry_conflict/4 , are called on all the nodes of the cluster. This allows you to receive events for the processes running on nodes that get shut down, or in case of net splits. The argument Reason in the callbacks can be: normal for expected operations. Crash reasons when processes die (for on_process_unregistered/5 and on_process_left/5 ). {syn_remote_scope_node_up, Scope, Node} for on_process_registered/5 and on_process_joined/5 when the callbacks are called due to nodes syncing. {syn_remote_scope_node_down, Scope, Node} for on_process_unregistered/5 and on_process_left/5 when the callbacks are called due to nodes disconnecting. syn_conflict_resolution for on_process_registered/5 and on_process_unregistered/5 during registry conflict resolution. undefined for on_process_unregistered/5 and on_process_left/5 when the processes died while the scope process had crashed. While all callbacks do not have a direct effect on Syn (their return value is ignored), a special case is the callback resolve_registry_conflict/4 . If specified, this is the method that will be used to resolve registry conflicts when detected. In case of net splits or race conditions, a specific name might get registered simultaneously on two different nodes. When this happens, the cluster experiences a registry naming conflict. Syn will resolve this Process Registry conflict by choosing a single process. By default, Syn keeps track of the time when a registration takes place with erlang:system_time/0 , compares values between conflicting processes and: Keeps the one with the higher value (the process that was registered more recently). Kills the other process by sending a kill signal with exit(Pid, {syn_resolve_kill, Name, Meta}) . This is a very simple mechanism that can be imprecise, as system clocks are not perfectly aligned in a cluster. If something more elaborate is desired, or if you do not want the discarded process to be killed (i.e. to perform a graceful shutdown), you MAY specify a custom handler that implements the resolve_registry_conflict/4 callback. To this effect, you may also store additional data to resolve conflicts in the Meta value, since it will be passed into the callback for both of the conflicting processes. If implemented, this method MUST return the pid() of the process that you wish to keep. The other process will not be killed, so you will have to decide what to do with it. If the custom conflict resolution method does not return one of the two Pids, or if the method crashes, none of the Pids will be killed and the conflicting name will be freed. Important Note: the conflict resolution method will be called on the two nodes where the conflicting processes are running on. Therefore, this method MUST be defined in the same way across all nodes of the cluster and have the same effect regardless of the node it is run on, or you will experience unexpected results. Examples The following callback module implements the on_process_unregistered/4 and the on_process_left/4 callbacks. Elixir defmodule MyCustomEventHandler do ‎ @ behaviour : syn_event_handler ‎ @ impl true def on_process_unregistered ( scope , name , pid , meta , reason ) do end ‎ @ impl true def on_process_left ( scope , group_name , pid , meta , reason ) do end end Erlang - module ( my_custom_event_handler ) . - behaviour ( syn_event_handler ) . - export ( [ on_process_unregistered / 4 ] ) . - export ( [ on_group_process_exit / 4 ] ) . - spec on_process_unregistered ( Scope : : atom ( ) , Name : : term ( ) , Pid : : pid ( ) , Meta : : term ( ) , Reason : : atom ( ) ) -&gt; term ( ) . on_process_unregistered ( Scope , Name , Pid , Meta , Reason ) -&gt; ok . - spec on_process_left ( Scope : : atom ( ) , GroupName : : term ( ) , Pid : : pid ( ) , Meta : : term ( ) , Reason : : atom ( ) ) -&gt; term ( ) . on_process_left ( Scope , GroupName , Pid , Meta , Reason ) -&gt; ok .","ref":"syn_event_handler.html","title":"syn_event_handler","type":"behaviour"},{"doc":"","ref":"syn_event_handler.html#c:on_group_process_updated/5","title":"syn_event_handler.on_group_process_updated/5","type":"callback"},{"doc":"","ref":"syn_event_handler.html#c:on_process_joined/5","title":"syn_event_handler.on_process_joined/5","type":"callback"},{"doc":"","ref":"syn_event_handler.html#c:on_process_left/5","title":"syn_event_handler.on_process_left/5","type":"callback"},{"doc":"","ref":"syn_event_handler.html#c:on_process_registered/5","title":"syn_event_handler.on_process_registered/5","type":"callback"},{"doc":"","ref":"syn_event_handler.html#c:on_process_unregistered/5","title":"syn_event_handler.on_process_unregistered/5","type":"callback"},{"doc":"","ref":"syn_event_handler.html#c:on_registry_process_updated/5","title":"syn_event_handler.on_registry_process_updated/5","type":"callback"},{"doc":"","ref":"syn_event_handler.html#c:resolve_registry_conflict/4","title":"syn_event_handler.resolve_registry_conflict/4","type":"callback"},{"doc":"Syn Syn (short for synonym ) is a scalable global Process Registry and Process Group manager for Erlang and Elixir, able to automatically manage dynamic clusters (addition / removal of nodes) and to recover from net splits. Syn is a replacement for Erlang/OTP global 's registry and pg modules. The main differences with these OTP's implementations are: OTP's global module chooses Consistency over Availability, therefore it can become difficult to scale when registration rates are elevated and the cluster becomes larger. If eventual consistency is acceptable in your case, Syn can considerably increase the registry's performance. Syn allows to attach metadata to every process, which also gets synchronized across the cluster. Syn implements cluster-wide callbacks on the main events, which are also properly triggered after net splits. [ Documentation ]","ref":"readme.html","title":"README","type":"extras"},{"doc":"What is a Process Registry? A global Process Registry allows registering a process on all the nodes of a cluster with a single Key. Consider this the process equivalent of a DNS server: in the same way you can retrieve an IP address from a domain name, you can retrieve a process from its Key. Typical Use Case: registering on a system a process that handles a physical device (using its serial number). What is a Process Group? A global Process Group is a named group which contains many processes, possibly running on different nodes. With the group Name, you can retrieve on any cluster node the list of these processes, or publish a message to all of them. This mechanism allows for Publish / Subscribe patterns. Typical Use Case: a chatroom. What is Syn? Syn is a Process Registry and Process Group manager that has the following features: Global Process Registry (i.e. a process is uniquely identified with a Key across all the nodes of a cluster). Global Process Group manager (i.e. a group is uniquely identified with a Name across all the nodes of a cluster). Any term can be used as Key and Name. PubSub mechanism: messages can be published to all members of a Process Group ( globally on all the cluster or locally on a single node). Subclusters by using Scopes allows great scalability. Dynamically sized clusters (addition / removal of nodes is handled automatically). Net Splits automatic resolution. Fast writes. Configurable callbacks. Processes are automatically monitored and removed from the Process Registry and Process Groups if they die.","ref":"readme.html#introduction","title":"README - Introduction","type":"extras"},{"doc":"In any distributed system you are faced with a consistency challenge, which is often resolved by having one master arbiter performing all write operations (chosen with a mechanism of leader election ), or through atomic transactions . Syn was born for applications of the IoT field. In this context, Keys used to identify a process are often the physical object's unique identifier (for instance, its serial or MAC address), and are therefore already defined and unique before hitting the system. The consistency challenge is less of a problem in this case, since the likelihood of concurrent incoming requests that would register processes with the same Key is extremely low and, in most cases, acceptable. In addition, write speeds were a determining factor in the architecture of Syn. Therefore, Availability has been chosen over Consistency and Syn implements strong eventual consistency .","ref":"readme.html#notes","title":"README - Notes","type":"extras"},{"doc":"For Elixir Add it to your deps: defp deps do [ { :syn , &quot;~&gt; 3.0&quot; } ] end For Erlang If you're using rebar3 , add syn as a dependency in your project's rebar.config file: { deps , [ { syn , { git , &quot;git://github.com/ostinelli/syn.git&quot; , { tag , &quot;3.1.0&quot; } } } ] } . Or, if you're using Hex.pm as package manager (with the rebar3_hex plugin): { deps , [ { syn , &quot;3.1.0&quot; } ] } . Ensure that syn is started with your application, for example by adding it in your .app file to the list of applications : { application , my_app , [ %% ... { applications , [ kernel , stdlib , sasl , syn , %% ... ] } , %% ... ] } .","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"So you want to contribute? That's great! Please follow the guidelines below. It will make it easier to get merged in. Before implementing a new feature, please submit a ticket to discuss what you intend to do. Your feature might already be in the works, or an alternative implementation might have already been discussed. Do not commit to master in your fork. Provide a clean branch without merge commits. Every pull request should have its own topic branch. In this way, every additional adjustments to the original pull request might be done easily, and squashed with git rebase -i . The updated branch will be visible in the same pull request, so there will be no need to open new pull requests when there are changes to be applied. Ensure that proper testing is included. To run Syn tests you simply have to be in the project's root directory and run: $ make test","ref":"readme.html#contributing","title":"README - Contributing","type":"extras"},{"doc":"Copyright (c) 2015-2021 Roberto Ostinelli and Neato Robotics, Inc. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"Syn accepts the following options that can be set as keys in the environment variable syn .","ref":"options.html","title":"Options","type":"extras"},{"doc":"Please see syn_event_handler for information on callbacks. The event handler module can be defined either by using the set_event_handler/1 method, or by setting the event_handler configuration variable. Elixir config :syn , event_handler : MyCustomEventHandler Erlang { syn , [ { event_handler , my_custom_event_handler } ] }","ref":"options.html#event_handler","title":"Options - event_handler","type":"extras"},{"doc":"Please see here for information on Scopes. Scopes can be defined either by using the add_node_to_scopes/1 method, or by setting the scopes configuration variable. Elixir config :syn , scopes : [ :devices , :users ] Erlang { syn , [ { scopes , [ devices , users ] } ] }","ref":"options.html#scopes","title":"Options - scopes","type":"extras"},{"doc":"By default, Syn doesn't enforce which processes perform the Registry and Process Groups operations: for instance, a process can be registered by a call running in another process. While this is fine in standard operations, those that end up updating a process' metadata could potentially lead to race conditions if caution is not taken. Operations are serialized by the authority node responsible for a process, however simultaneous requests coming from different processes to update a specific process' metadata can result in unexpected consequences, even if this doesn't compromise Syn's strict eventual consistency (i.e. the data across the cluster will still eventually converge). Imagine for instance that a process A has a metadata of attributes such as [{color, &quot;blue&quot;}] . A different process might request to update process A's metadata to include size, by setting its metadata to [{color, &quot;blue&quot;}, {size, 100}] . At almost the same time another process might also request to update process A's metadata to include weight, by setting its metadata to [{color, &quot;blue&quot;}, {weight, 1.0}] . These requests will be delivered to the authority node which will treat them sequentially. Therefore, the first incoming request (for eg. the one that sets the size) will be overwritten shortly after by the second incoming request (the one that sets the weight), thus resulting in the loss of the {size, 100} tuple in the process' metadata. The end result will be that process A' metadata will be propagated to the whole cluster as [{color, &quot;blue&quot;}, {weight, 1.0}] . This can be circumvented by proper application design, for instance by ensuring that a single process is always responsible for updating a specific process' metadata. When enabled, Syn's strict_mode is a helper to enforce that a process can only update its own metadata. This basically means that the Pid parameter of most methods must be self() . strict_mode is a global setting that cannot be specified on a per-scope basis. The same setting SHOULD be set on every Erlang cluster node running Syn. Elixir With strict_mode turned on: iex&gt; pid = spawn ( fn -&gt; receive do _ -&gt; :ok end end ) # PID &lt; 0 . 108 . 0 &gt; iex&gt; :syn . register ( :users , &quot;hedy&quot; , pid ) . { :error , :not_self } iex&gt; :syn . register ( :users , &quot;hedy&quot; , self ( ) ) . :ok Erlang With strict_mode turned on: 1 &gt; Pid = spawn ( fun ( ) -&gt; receive _ -&gt; ok end end ) . &lt; 0.83 . 0 &gt; 2 &gt; syn : register ( users , &quot;hedy&quot; , Pid ) . { error , not_self } 3 &gt; syn : register ( users , &quot;hedy&quot; , self ( ) ) . ok Strict mode can be turned on by setting the strict_mode configuration variable. Elixir config :syn , strict_mode : true Erlang { syn , [ { strict_mode , true } ] }","ref":"options.html#strict_mode","title":"Options - strict_mode","type":"extras"},{"doc":"","ref":"internals.html","title":"Internals","type":"extras"},{"doc":"In Syn, every node is the authority in terms of the processes that run on it. This means that all register / unregister / join / leave operations for a specific process are routed to the syn process (registry, pg) that runs on the specific process' node. It is then the responsibility of this node to communicate the operation results and propagate them to the other nodes. This serializes per node operations and allows keeping per node consistency.","ref":"internals.html#node-authority","title":"Internals - Node Authority","type":"extras"},{"doc":"Syn implement Scopes, which are a way to create namespaced, logical overlay networks running on top of the Erlang distribution cluster. Nodes that belong to the same Scope will form a &quot;subcluster&quot;: they will synchronize data between themselves, and themselves only. Note that all of the data related to a Scope will be replicated to every node of a subcluster, so that every node has a quick read access to it. Scope processes When you add a node to a scope (see add_node_to_scopes/1 ) i.e. users , the following happens: 2 new gen_server processes get created (aka &quot;scope processes&quot;), in the given example named syn_registry_users (for registry) and syn_pg_users (for process groups). 4 new ETS tables get created: syn_registry_by_name_users (of type set ). syn_registry_by_pid_users (of type bag ). syn_pg_by_name_users (of type ordered_set ). syn_pg_by_pid_users (of type ordered_set ). These tables are owned by the syn_backbone process, so that if the related scope processes were to crash the data is not lost. In such case, upon respawn the scope process purges the data of all remote nodes, rebuilds the monitors for the local processes that are still alive and removes from the tables the ones that died meanwhile. The remote data will then get synchronized again. The 2 newly created scope processes each join a subcluster (one for registry, one for process groups) with the other processes in the Erlang distributed cluster that handle the same Scope (which have the same name). Subcluster protocol Joining Just after initialization, every scope process tries to send a discovery message in format {'3.0', discover, self()} to every process with the same name running on all the nodes in the Erlang cluster. Scope processes monitor node events, so when a new node joins the cluster the same discovery message is sent to the new node. When a scope process receives the discovery message, it: Replies with its local data with an ack message in format {'3.0', ack_sync, self(), LocalData} . Starts monitoring the remote scope node process. Adds the remote node to the list of the subcluster nodes. The scope process that receives the ack_sync message: Stores the received data of the remote node. If it's an unknown node, it: Starts monitoring the remote scope node process. Sends it its local data with another ack message. Adds the remote node to the list of the subcluster nodes. Leaving When a scope process of a remote node dies, all the other scope processes are notified because they were monitoring it. The data related to the remote node that left the subcluster is removed locally on every node.","ref":"internals.html#scope-subclusters","title":"Internals - Scope Subclusters","type":"extras"}]